/*
  EASYROBOT2 function.ino

  Mirco Segatello 2016  
*/

#define VBAT 0    // A0 Battery Voltage
#define AN1 1      // A1 Line sensor
#define AN2 2      // A2 Line sensor
#define AN3 3      // A3 Line sensor
#define DIRA 3    // Direction motor A (0=forward)
#define PWMA 5    // PWM motor A
#define DIRB 2    // Direction motor B (0=forward)
#define PWMB 6    //  PWM motor B
#define TRIG_PIN 9  //Trigger pin Ultrasonic Sensor
#define ECHO_PIN 8  //Echo pin Ultrasonic Sensor

void initialize() 
{
  // Setup pin
  pinMode(DIRA,OUTPUT);
  pinMode(PWMA,OUTPUT);  
  pinMode(DIRB,OUTPUT);  
  pinMode(PWMB,OUTPUT);
  pinMode(TRIG_PIN,OUTPUT);
  digitalWrite(TRIG_PIN, LOW);
  pinMode(ECHO_PIN,INPUT);
}

void turn(int power, int turn)
{
      //forward function 
      int powerA, powerB;
      powerA=power-turn;
      powerB=power+turn;
      powerA=constrain(powerA,-255,255);
      powerB=constrain(powerB,-255,255);
      if (powerA>0)
      {
          digitalWrite(DIRA, LOW);
          analogWrite(PWMA, powerA);
      }
      else
      {
          digitalWrite(DIRA, HIGH);
          analogWrite(PWMA, -powerA);            
      }

      if (powerB>0)
      {
          digitalWrite(DIRB, LOW);
          analogWrite(PWMB, powerB);      
      }
      else
      {
          digitalWrite(DIRB, HIGH);
          analogWrite(PWMB, -powerB);               
      }
}


void forward(int power)
{
    //forward function 
      power=constrain(power,0,255);
      digitalWrite(DIRA, LOW);
      digitalWrite(DIRB, LOW);
      analogWrite(PWMA, power);
      analogWrite(PWMB, power);
}

void reverse(int power)
{
      power=constrain(power,0,255);
      digitalWrite(DIRA, HIGH);
      digitalWrite(DIRB, HIGH);
      analogWrite(PWMA, power);
      analogWrite(PWMB, power);
}

void stop()
{
      // stop function
      digitalWrite(DIRA, LOW);
      digitalWrite(DIRB, LOW);
      analogWrite(PWMA, 0);
      analogWrite(PWMB, 0);    
}

int distance()
{
  
  int duration, distanceCm;
  digitalWrite(TRIG_PIN, HIGH);
  delayMicroseconds(10);
  
  digitalWrite(TRIG_PIN, LOW);
  duration = pulseIn(ECHO_PIN,HIGH);
 
  //convert the time into a distance
  distanceCm = duration / 29.1 / 2.0;
  return distanceCm;
  
}


float VBat()
{
  float VBatLevel = 2*float(analogRead(A0))*5.0/1024.0;
  return VBatLevel;
}


float CNY70(int num_sens)
{
  float CNY;
  switch (num_sens)
  {
    case 1: 
      CNY = float(analogRead(A1))*5.0/1024.0;
      break;
    case 2:
      CNY = float(analogRead(A2))*5.0/1024.0;
      break;
    case 3:
      CNY = float(analogRead(A3))*5.0/1024.0;
      break;
  }  
  return CNY;
}

